/* --- geometry and timing of the menu --- 
	values are the lists with parameters for different menu levels
	for this menu: [blue_level, green_level, red_level]
*/
var MENU_POS1 = {
	// item sizes for different levels of menu
	'height': [20, 20, 20],
	'width': [120, 150, 150],
	// menu block offset from the origin:
	//	for root level origin is upper left corner of the page
	//	for other levels origin is upper left corner of parent item
	'block_top': [35, 23, 5],
	'block_left': [23, 0, 130],
	// offsets between items of the same level
	'top': [0, 21, 21],
	'left': [119, 0, 0],
	// time in milliseconds before menu is hidden after cursor has gone out
	// of any items
	'hide_delay': [200, 200, 200]
};

/* --- dynamic menu styles ---
note: you can add as many style properties as you wish but be not all browsers
are able to render them correctly. The only relatively safe properties are
'color' and 'background'.
*/
var MENU_STYLES1 = {
	// default item state when it is visible but doesn't have mouse over
	'onmouseout': [
		'color', ['#FFFFFF', '#FFFFFF', '#FFFFFF'], 
		'background', ['#990100', '#990100', '#990100'],
		'textDecoration', ['none', 'none', 'none'],
		'fontWeight', ['normal', 'normal', 'bold'],
	],
	// state when item has mouse over it
	'onmouseover': [
		'color', ['#000000', '#000000', '#000000'], 
		'background', ['#ffcccc', '#ffcccc', '#ffcccc'],
		'textDecoration', ['underline', 'underline', 'none'],
		'fontWeight', ['normal', 'normal', 'bold'],
	],
	// state when mouse button has been pressed on the item
	'onmousedown': [
		'color', ['#FFFFFF', '#000000', '#000000'], 
		'background', ['#d6deec', '#d6deec', '#d6deec'],
		'textDecoration', ['underline', 'none', 'none'],
		'fontWeight', ['normal', 'normal', 'bold'],
	]
};
	
