<?php
/*
Descripción: El algoritmo del punto en un polígono permite comprobar mediante
programación si un punto está dentro de un polígono o fuera de ello.
Autor: Michaël Niessen (2009)
Sito web: AssemblySys.com
 
Si este código le es útil, puede mostrar su
agradecimiento a Michaël ofreciéndole un café ;)
PayPal: michael.niessen@assemblysys.com
 
Mientras estos comentarios (incluyendo nombre y detalles del autor) estén
incluidos y SIN ALTERAR, este código está distribuido bajo la GNU Licencia
Pública General versión 3: http://www.gnu.org/licenses/gpl.html
*/
 
class pointLocation {
    var $pointOnVertex = true; // Checar si el punto se encuentra exactamente en uno de los vértices?
 
    function pointLocation() {
    }
 
        function pointInPolygon($point, $polygon, $pointOnVertex = true) {
        $this->pointOnVertex = $pointOnVertex;
 
        // Transformar la cadena de coordenadas en matrices con valores "x" e "y"
        $point = $this->pointStringToCoordinates($point);
        $vertices = array(); 
        foreach ($polygon as $vertex) {
            $vertices[] = $this->pointStringToCoordinates($vertex); 
        }
 
        // Checar si el punto se encuentra exactamente en un vértice
        if ($this->pointOnVertex == true and $this->pointOnVertex($point, $vertices) == true) {
            return "dentro";
        }
 
        // Checar si el punto está adentro del poligono o en el borde
        $intersections = 0; 
        $vertices_count = count($vertices);
 
        for ($i=1; $i < $vertices_count; $i++) {
            $vertex1 = $vertices[$i-1]; 
            $vertex2 = $vertices[$i];
            if ($vertex1['y'] == $vertex2['y'] and $vertex1['y'] == $point['y'] and $point['x'] > min($vertex1['x'], $vertex2['x']) and $point['x'] < max($vertex1['x'], $vertex2['x'])) { // Checar si el punto está en un segmento horizontal
                return "dentro";
            }
            if ($point['y'] > min($vertex1['y'], $vertex2['y']) and $point['y'] <= max($vertex1['y'], $vertex2['y']) and $point['x'] <= max($vertex1['x'], $vertex2['x']) and $vertex1['y'] != $vertex2['y']) { 
                $xinters = ($point['y'] - $vertex1['y']) * ($vertex2['x'] - $vertex1['x']) / ($vertex2['y'] - $vertex1['y']) + $vertex1['x']; 
                if ($xinters == $point['x']) { // Checar si el punto está en un segmento (otro que horizontal)
                    return "dentro";
                }
                if ($vertex1['x'] == $vertex2['x'] || $point['x'] <= $xinters) {
                    $intersections++; 
                }
            } 
        } 
        // Si el número de intersecciones es impar, el punto está dentro del poligono. 
        if ($intersections % 2 != 0) {
            return "dentro";
        } else {
            return "fuera";
        }
    }
 
    function pointOnVertex($point, $vertices) {
        foreach($vertices as $vertex) {
            if ($point == $vertex) {
                return true;
            }
        }
 
    }
 
    function pointStringToCoordinates($pointString) {
        $coordinates = explode(" ", $pointString);
        return array("x" => $coordinates[0], "y" => $coordinates[1]);
    }
 
}

include("../consultas/dfp545_dbinfo.php");    
$conexion = mysql_connect($server, $user, $password) or die(mysql_error());
mysql_select_db($database, $conexion) or die(mysql_error());


$cant_geo = 0;
$id_cerca2 = 0;
$estado="";

//$sql2="select id_vehi, id_cerca_total from geocerca where (tipo_cerca='0' or (tipo_cerca='1' and estado='1')) and conteo='0' order by id_cerca Limit 1"; 
$sql2="select id_vehi, id_cerca_total,tipo_cerca from geocerca where (tipo_cerca='0' and estado='1') or (tipo_cerca='1' and estado='1') GROUP BY id_cerca_total order by id_cerca"; 
$id_cerca2 = 0;

$res2=mysql_query($sql2,$conexion);
while($row = mysql_fetch_array($res2)) {
    $id_cerca_total=$row["id_cerca_total"];
    $id_vehi=$row["id_vehi"];
    $tipo_cerca=$row["tipo_cerca"];
    $estado_control="";
    $pointLocation = new pointLocation();
    $polygon = array();

    $sql3="select id_max_reco from vehiculo where id_vehi='$id_vehi' limit 1"; 
    
    $res3=mysql_query($sql3,$conexion);
    while($row = mysql_fetch_array($res3)) {
        $id_max_reco=$row["id_max_reco"];
    }

    $sql4="select co_coordx,co_coordy,f_fereg,ho_hora,id_chofer from recorrido where id_reco='$id_max_reco'"; 
    
    $res4=mysql_query($sql4,$conexion);
    while($row = mysql_fetch_array($res4)) {
        $co_coordx=$row["co_coordx"];
        $co_coordy=$row["co_coordy"];
        $f_fereg=$row["f_fereg"];
        $ho_hora=$row["ho_hora"];
        $id_chofer=$row["id_chofer"];
        $points = array($co_coordx." ".$co_coordy);
    }

    $sql5="select estado_control,funcionando from opciones_geocerca where id_cerca_total='$id_cerca_total'"; 
    
    $res5=mysql_query($sql5,$conexion);
    while($row = mysql_fetch_array($res5)) {
        $estado_control=$row["estado_control"];
        $funcionando=$row["funcionando"];
    }
    
    //echo $id_cerca_total."-".$id_vehi."-".$points[0]."-".$f_fereg."-".$ho_hora."-".$id_max_reco."-".$id_chofer."-".$estado_control."-".$tipo_cerca."-".$funcionando;
    //echo "<br>";

    ////Busca geocercas en base de datos
    $sql6="select co_coordx, co_coordy, id_vehi from geocerca where id_cerca_total='$id_cerca_total'"; 
       
    $res6=mysql_query($sql6,$conexion);
    while($row = mysql_fetch_array($res6)) {
        $co_coordx=$row["co_coordx"];
        $co_coordy=$row["co_coordy"];
        $coordenadas = $co_coordx." ".$co_coordy;
        array_push($polygon, $coordenadas);
    }
    
    foreach($points as $key => $point) {
        $estado_actual = $pointLocation->pointInPolygon($point, $polygon);
    }

    if($estado_control=="in" && $estado_actual=="fuera" && $tipo_cerca=="0" && $func=="0"){
      $estado = "out";
    }elseif($estado_control=="out" && $estado_actual=="dentro" && $tipo_cerca=="0" && $func=="1"){
      $estado = "in";
    }elseif($estado_control=="in" && $estado_actual=="fuera" && $tipo_cerca=="1"){
      $estado = "out";
    }elseif($estado_control=="out" && $estado_actual=="dentro" && $tipo_cerca=="1"){
      $estado = "in";
    }
    
    if($estado=="in" or $estado=="out"){
        $sql7="select estado_control from opciones_geocerca where id_cerca_total='$id_cerca_total'"; 
        
        $res7=mysql_query($sql7,$conexion);
        while($row = mysql_fetch_array($res7)) {
            $estado_ant=$row["estado_control"];
        }
        
        if($estado=='out' && $estado_ant=='in' && $tipo_cerca=="0" && $func=="0"){
            $id_alerta = "1";
            mysql_query("insert into historico_alerta (id_alerta,id_vehi,fe_inicio_alerta,id_reco,ho_inicio_alerta,id_chofer) values
                    ('$id_alerta','$id_vehi','$f_fereg','$id_reco','$ho_hora','$id_chofer')",$conexion);
            mysql_query("update opciones_geocerca set estado_control='out',funcionando='1' where id_cerca_total='$id_cerca_total'",$conexion);
        }else if($estado=='in' && $estado_ant=='out' && $tipo_cerca=="0" && $func=="1"){
            $al_atencion = "AUTOMATICO";
            $sql6="select max(id_historico) as id_historico from historico_alerta where id_vehi='$id_vehi'"; 
                        
            $res6=mysql_query($sql6,$conexion);
            while($row = mysql_fetch_array($res6)) {
                $id_historico=$row["id_historico"];
            }
            mysql_query("update historico_alerta set fe_fin_alerta='$f_fereg',ho_fin_alerta='$ho_hora',al_atencion='$al_atencion' where id_historico='$id_historico'",$conexion);
            mysql_query("update opciones_geocerca set estado_control='in',funcionando='0' where id_cerca_total='$id_cerca_total'",$conexion);
        }else if($estado=='in' && $estado_ant=='out' && $tipo_cerca=="1"){
            $id_alerta = "1";
            mysql_query("insert into historico_alerta (id_alerta,id_vehi,fe_inicio_alerta,id_reco,ho_inicio_alerta,id_chofer,id_cerca_total,estado,tipo_cerca) values
                    ('$id_alerta','$id_vehi','$f_fereg','$id_reco','$ho_hora','$id_chofer','$id_cerca_total','$estado','$tipo_cerca')",$conexion);
            mysql_query("update opciones_geocerca set estado_control='in' where id_cerca_total='$id_cerca_total'",$conexion);  
        }else if($estado=='out' && $estado_ant=='in' && $tipo_cerca=="1"){
            $id_alerta = "1";
            mysql_query("insert into historico_alerta (id_alerta,id_vehi,fe_inicio_alerta,id_reco,ho_inicio_alerta,id_chofer,id_cerca_total,estado,tipo_cerca) values
                    ('$id_alerta','$id_vehi','$f_fereg','$id_reco','$ho_hora','$id_chofer','$id_cerca_total','$estado','$tipo_cerca')",$conexion);
            mysql_query("update opciones_geocerca set estado_control='out' where id_cerca_total='$id_cerca_total'",$conexion);
        }

    }
        
    
}
    
?>
<!--
<head>
<meta http-equiv="refresh" content="30">
Ejecutando .....
</head>
-->
