<?php
/*
Descripción: El algoritmo del punto en un polígono permite comprobar mediante
programación si un punto está dentro de un polígono o fuera de ello.
Autor: Michaël Niessen (2009)
Sito web: AssemblySys.com
 
Si este código le es útil, puede mostrar su
agradecimiento a Michaël ofreciéndole un café ;)
PayPal: michael.niessen@assemblysys.com
 
Mientras estos comentarios (incluyendo nombre y detalles del autor) estén
incluidos y SIN ALTERAR, este código está distribuido bajo la GNU Licencia
Pública General versión 3: http://www.gnu.org/licenses/gpl.html
*/
 
class pointLocation {
    var $pointOnVertex = true; // Checar si el punto se encuentra exactamente en uno de los vértices?
 
    function pointLocation() {
    }
 
        function pointInPolygon($point, $polygon, $pointOnVertex = true) {
        $this->pointOnVertex = $pointOnVertex;
 
        // Transformar la cadena de coordenadas en matrices con valores "x" e "y"
        $point = $this->pointStringToCoordinates($point);
        $vertices = array(); 
        foreach ($polygon as $vertex) {
            $vertices[] = $this->pointStringToCoordinates($vertex); 
        }
 
        // Checar si el punto se encuentra exactamente en un vértice
        if ($this->pointOnVertex == true and $this->pointOnVertex($point, $vertices) == true) {
            return "dentro";
        }
 
        // Checar si el punto está adentro del poligono o en el borde
        $intersections = 0; 
        $vertices_count = count($vertices);
 
        for ($i=1; $i < $vertices_count; $i++) {
            $vertex1 = $vertices[$i-1]; 
            $vertex2 = $vertices[$i];
            if ($vertex1['y'] == $vertex2['y'] and $vertex1['y'] == $point['y'] and $point['x'] > min($vertex1['x'], $vertex2['x']) and $point['x'] < max($vertex1['x'], $vertex2['x'])) { // Checar si el punto está en un segmento horizontal
                return "dentro";
            }
            if ($point['y'] > min($vertex1['y'], $vertex2['y']) and $point['y'] <= max($vertex1['y'], $vertex2['y']) and $point['x'] <= max($vertex1['x'], $vertex2['x']) and $vertex1['y'] != $vertex2['y']) { 
                $xinters = ($point['y'] - $vertex1['y']) * ($vertex2['x'] - $vertex1['x']) / ($vertex2['y'] - $vertex1['y']) + $vertex1['x']; 
                if ($xinters == $point['x']) { // Checar si el punto está en un segmento (otro que horizontal)
                    return "dentro";
                }
                if ($vertex1['x'] == $vertex2['x'] || $point['x'] <= $xinters) {
                    $intersections++; 
                }
            } 
        } 
        // Si el número de intersecciones es impar, el punto está dentro del poligono. 
        if ($intersections % 2 != 0) {
            return "dentro";
        } else {
            return "fuera";
        }
    }
 
    function pointOnVertex($point, $vertices) {
        foreach($vertices as $vertex) {
            if ($point == $vertex) {
                return true;
            }
        }
 
    }
 
    function pointStringToCoordinates($pointString) {
        $coordinates = explode(" ", $pointString);
        return array("x" => $coordinates[0], "y" => $coordinates[1]);
    }
 
}

include("../consultas/dfp545_dbinfo.php");    
$conexion = mysql_connect($server, $user, $password) or die(mysql_error());
mysql_select_db($database, $conexion) or die(mysql_error());


$cant_geo = 0;
$id_cerca2 = 0;
$estado="";
$id_historico = 0;
$al_atencion = '';

$sql="select id_alerta,al_envio_mail,id_historico,id_reco,id_vehi from historico_alerta where al_envio_mail='1' and al_atencion='' and
      (id_alerta='5' or id_alerta='51' or id_alerta='50')"; 
    $res=mysql_query($sql,$conexion);
    while($row = mysql_fetch_array($res)) {
        $id_historico=$row["id_historico"];
        $id_reco=$row["id_reco"];
        $id_vehi=$row["id_vehi"];
	$id_alarma=$row["id_alerta"];
	$act_alarma='1';
	$al_atencion = '';

        $sql4="select id_emp from vehiculo where id_vehi='$id_vehi'"; 
        $res4=mysql_query($sql4,$conexion);
        while($row = mysql_fetch_array($res4)) {
            $id_emp=$row["id_emp"];
        }

	echo "<br>";        
        if($id_historico<>0){
            ####Buscar geocercas de id_vehi
	    
            $sql2="select id_cerca_total,tipo_cerca,id_emp,id_vehi from geocerca where tipo_cerca='1' and estado='1' and id_vehi='$id_vehi' or 
		   id_emp='$id_emp' GROUP BY id_cerca_total order by id_cerca"; 
            $res2=mysql_query($sql2,$conexion);
            while($row = mysql_fetch_array($res2)) {
                $id_cerca_total=$row["id_cerca_total"];
                $tipo_cerca=$row["tipo_cerca"];
                $id_emp=$row["id_emp"];
        	$estado_actual="";
	        $pointLocation = new pointLocation();
		$polygon = array();
                
                $sql4="select co_coordx,co_coordy from recorrido where id_reco='$id_reco' limit 1"; 
                $res4=mysql_query($sql4,$conexion);
                while($row = mysql_fetch_array($res4)) {
                    $co_coordx=$row["co_coordx"];
                    $co_coordy=$row["co_coordy"];
                    $points = array($co_coordx." ".$co_coordy);
                }
                
                $sql4="select taller from opciones_geocerca where id_cerca_total='$id_cerca_total' limit 1";
                $res4=mysql_query($sql4,$conexion);
                while($row = mysql_fetch_array($res4)) {
                    $taller=$row["taller"];
                }
	
                ////Busca geocercas en base de datos
                $sql6="select co_coordx, co_coordy, id_vehi from geocerca where id_cerca_total='$id_cerca_total' order by id_cerca asc"; 

                $i=0;           
                $res6=mysql_query($sql6,$conexion);
                while($row = mysql_fetch_array($res6)) {
                    $co_coordx=$row["co_coordx"];
                    $co_coordy=$row["co_coordy"];
                    $coordenadas = $co_coordx." ".$co_coordy;
		    
                    if($i==0){
                        $coord_inicio = $coordenadas;
                        $i++;
                    }
                    array_push($polygon, $coordenadas);
                }
                array_push($polygon, $coord_inicio);	
			
                foreach($points as $key => $point) {
                    $estado_actual = $pointLocation->pointInPolygon($point, $polygon);
                }
                
                echo $id_alarma."-".$estado_actual;
                echo "<br>";

		
		if($id_alarma=='5' and $estado_actual=='dentro'){
		    #Si esta dentro de una geocerca, desactiva la alarma
		    $text='Desactiva alarma Puerta Abierta';
		    echo $text;
		    $al_atencion='Dentro de geocerca';
		}elseif($id_alarma==50 and $estado_actual=='dentro' and $taller<>0){
                    $test='Desactiva alarma Desc de bateria, dentro de un taller';
		    echo $text;
		    $al_atencion='Dentro de un taller';
		}elseif($id_alarma=='51' and $estado_actual=='dentro' and $taller<>0){
                    $test='Desactiva alarma Antivandalico, dentro de un taller';
		    echo $text;
                    $al_atencion='Dentro de un taller';
                }

		#Fin de consulta por geocerca
            }    
	    echo "<br>";        
	    echo "al_atencion=".$al_atencion;
	    if($al_atencion==''){
		mysql_query("update historico_alerta set al_envio_mail='0',al_atencion='' where id_historico='$id_historico'",$conexion);
	    }else{
                mysql_query("update historico_alerta set al_envio_mail='0',al_atencion='$al_atencion' where id_historico='$id_historico'",$conexion);
	    }

	    #Fin de alarma
        }
    }
?>



