/**  * Listener para el formulario  */

function addListener(element, type, expression, bubbling) {
    bubbling = bubbling || false;
    if(element.addEventListener){ // Standard
        element.addEventListener(type, expression, bubbling);
        return true;
    }else if(element.attachEvent) { // IE
        element.attachEvent('on' + type, expression);
        return true;
    }else return false;
}

window.onload = function(){
    var fooArr = [], barArr = [], bazArr = [];
    var options = {
        zoom: 9
        , center: new google.maps.LatLng(18.2, -66.3)
        , mapTypeId: google.maps.MapTypeId.ROADMAP
        };
    
    var map = new google.maps.Map(document.getElementById('map'), options);
    
    var southWest = new google.maps.LatLng(17.85, -67.35);
    var northEast = new google.maps.LatLng(18.55, -65.2);
    var lngSpan = northEast.lng() - southWest.lng();
    var latSpan = northEast.lat() - southWest.lat();
    for(var i=1; i<=10; i++){
        var lat = southWest.lat() + latSpan * Math.random();
        var lng = southWest.lng() + lngSpan * Math.random();
        var latlng = new google.maps.LatLng(lat, lng);
        var marker = new google.maps.Marker({
            position: latlng
        });
    
    if((i%3) == 0){
        bazArr.push(marker); }
    else if((i%2) == 0){
        barArr.push(marker); }
    else{
        fooArr.push(marker); }
    }
    
    document.getElementById('foo').checked = true;
    for(var i in fooArr){
        fooArr[i].setMap(map);
        }
    
    addListener(document.getElementById('foo'), 'click', function(){
        if(this.checked){
            for(var i in fooArr){
                fooArr[i].setMap(map);
                }
        }else{
            for(var i in fooArr){
                fooArr[i].setMap(null);
                }
            }
    });
    
    addListener(document.getElementById('bar'), 'click', function(){
        if(this.checked){
            for(var i in barArr){
                barArr[i].setMap(map);
                }
            }else{
                for(var i in barArr){
                    barArr[i].setMap(null);
                    }
                }
    });
    
    addListener(document.getElementById('baz'), 'click', function(){
        if(this.checked){
            for(var i in bazArr){
                bazArr[i].setMap(map);
                }
            }else{
                for(var i in bazArr){
                    bazArr[i].setMap(null);
                }
            }
    });

};