<?php
/*
Descripción: El algoritmo del punto en un polígono permite comprobar mediante
programación si un punto está dentro de un polígono o fuera de ello.
Autor: Michaël Niessen (2009)
Sito web: AssemblySys.com
 
Si este código le es útil, puede mostrar su
agradecimiento a Michaël ofreciéndole un café ;)
PayPal: michael.niessen@assemblysys.com
 
Mientras estos comentarios (incluyendo nombre y detalles del autor) estén
incluidos y SIN ALTERAR, este código está distribuido bajo la GNU Licencia
Pública General versión 3: http://www.gnu.org/licenses/gpl.html
*/
 
class pointLocation {
    var $pointOnVertex = true; // Checar si el punto se encuentra exactamente en uno de los vértices?
 
    function pointLocation() {
    }
 
        function pointInPolygon($point, $polygon, $pointOnVertex = true) {
        $this->pointOnVertex = $pointOnVertex;
 
        // Transformar la cadena de coordenadas en matrices con valores "x" e "y"
        $point = $this->pointStringToCoordinates($point);
        $vertices = array(); 
        foreach ($polygon as $vertex) {
            $vertices[] = $this->pointStringToCoordinates($vertex); 
        }
 
        // Checar si el punto se encuentra exactamente en un vértice
        if ($this->pointOnVertex == true and $this->pointOnVertex($point, $vertices) == true) {
            return "dentro";
        }
 
        // Checar si el punto está adentro del poligono o en el borde
        $intersections = 0; 
        $vertices_count = count($vertices);
 
        for ($i=1; $i < $vertices_count; $i++) {
            $vertex1 = $vertices[$i-1]; 
            $vertex2 = $vertices[$i];
            if ($vertex1['y'] == $vertex2['y'] and $vertex1['y'] == $point['y'] and $point['x'] > min($vertex1['x'], $vertex2['x']) and $point['x'] < max($vertex1['x'], $vertex2['x'])) { // Checar si el punto está en un segmento horizontal
                return "dentro";
            }
            if ($point['y'] > min($vertex1['y'], $vertex2['y']) and $point['y'] <= max($vertex1['y'], $vertex2['y']) and $point['x'] <= max($vertex1['x'], $vertex2['x']) and $vertex1['y'] != $vertex2['y']) { 
                $xinters = ($point['y'] - $vertex1['y']) * ($vertex2['x'] - $vertex1['x']) / ($vertex2['y'] - $vertex1['y']) + $vertex1['x']; 
                if ($xinters == $point['x']) { // Checar si el punto está en un segmento (otro que horizontal)
                    return "dentro";
                }
                if ($vertex1['x'] == $vertex2['x'] || $point['x'] <= $xinters) {
                    $intersections++; 
                }
            } 
        } 
        // Si el número de intersecciones es impar, el punto está dentro del poligono. 
        if ($intersections % 2 != 0) {
            return "dentro";
        } else {
            return "fuera";
        }
    }
 
    function pointOnVertex($point, $vertices) {
        foreach($vertices as $vertex) {
            if ($point == $vertex) {
                return true;
            }
        }
 
    }
 
    function pointStringToCoordinates($pointString) {
        $coordinates = explode(" ", $pointString);
        return array("x" => $coordinates[0], "y" => $coordinates[1]);
    }
 
}

include("../consultas/dfp545_dbinfo.php");    
$conexion = mysql_connect($server, $user, $password) or die(mysql_error());
mysql_select_db($database, $conexion) or die(mysql_error());


$cant_geo = 0;
$id_cerca2 = 0;
$estado="";

//Buscar id_empresas que tengan geocercas

$sql7="select ANY_VALUE(id_vehi),id_emp from geocerca where tipo_cerca='1' and estado='1' and id_emp<>'1' GROUP BY id_emp";

$res7=mysql_query($sql7,$conexion);
while($row = mysql_fetch_array($res7)) {
	$id_emp=$row["id_emp"];
	echo "<br>--------------------------------------". $id_emp;



	$sql3="select id_max_reco,id_vehi,geocerca,id_cerca_total,id_historico,act_contador,id_reco_geo from vehiculo where id_emp='$id_emp'";
        
	$res3=mysql_query($sql3,$conexion);
	while($row = mysql_fetch_array($res3)) {
		$j=0;
		//$estado='na';
		$id_max_reco=$row["id_max_reco"];
		$id_vehi=$row["id_vehi"];
		$estado_control=$row["geocerca"];
		$dentro_de_geocerca=$row["id_cerca_total"];
		$id_historico_save=$row["id_historico"];
		$act_contador=$row["act_contador"];
		$id_reco_geo=$row["id_reco_geo"];

		echo "<br>Id_vehi:".$id_vehi;
				
		$cambio_estado = 0;
		//Descarta la busqueda si el id_max_reco no ha variado
		if($id_max_reco <> $id_reco_geo){

			$sql4="select co_coordx,co_coordy,f_fereg,ho_hora,id_chofer,din2 from recorrido where id_reco='$id_max_reco' limit 1";

                        $res4=mysql_query($sql4,$conexion);
                        while($row = mysql_fetch_array($res4)) {
                        	$co_coordx=$row["co_coordx"];
                                $co_coordy=$row["co_coordy"];
                                $f_fereg=$row["f_fereg"];
                                $ho_hora=$row["ho_hora"];
                                $id_chofer=$row["id_chofer"];
                                $din2=$row["din2"];
                                $points = array($co_coordx." ".$co_coordy);
			}

                        $sql5="select funcionando,taller from opciones_geocerca where id_cerca_total='$id_cerca_total' limit 1";

                        $taller=0;
                        $res5=mysql_query($sql5,$conexion);
                        while($row = mysql_fetch_array($res5)) {
                        	$func=$row["funcionando"];
                                $taller=$row["taller"];
                        }

                        ////Parametro de busqueda de Empresas con servicio de centro de control
                        $sql5="select centro_control from empresa where id_emp='$id_emp' limit 1";

                        $res5=mysql_query($sql5,$conexion);
                        while($row = mysql_fetch_array($res5)) {
                        	$centro_control_act=$row["centro_control"];
                        }

			
			$sql2="select ANY_VALUE(id_vehi), id_cerca_total,ANY_VALUE(tipo_cerca),ANY_VALUE(id_emp) from geocerca where tipo_cerca='1' and estado='1' and id_emp='$id_emp' GROUP BY id_cerca_total"; 
			$id_cerca2 = 0;

			//Variable para actualizar id_reco_geo
			$actualiza_id = 1;

			$res2=mysql_query($sql2,$conexion);
			while($row = mysql_fetch_array($res2)) {

				if($actualiza_id == 1){
					mysql_query("update vehiculo set id_reco_geo='$id_max_reco' where id_vehi='$id_vehi'",$conexion);
					$actualiza_id++;
				}

				$estado='na';
				$id_cerca_total=$row["id_cerca_total"];
				$tipo_cerca=$row["ANY_VALUE(tipo_cerca)"];
				$id_emp=$row["ANY_VALUE(id_emp)"];
				//$estado='';
				
				#echo $id_cerca_total."-".$id_vehi."-".$tipo_cerca."-".$id_emp;
				#echo "<br>";    

				$pointLocation = new pointLocation();
				$polygon = array();
								
				if($estado_control==''){
					$estado_control='out';
				}

				echo "<br>&nbsp;&nbsp;".$id_cerca_total."-".$id_vehi."-".$points[0]."-".$f_fereg."-".$ho_hora."-".$id_max_reco."-".$id_chofer."-".$estado_control."-".$tipo_cerca."-".$func;
				

				////Busca geocercas en base de datos
				$sql6="select co_coordx, co_coordy, id_vehi,nombre_geocerca,tipo_geo_ciudad from geocerca where id_cerca_total='$id_cerca_total' order by id_cerca asc"; 
				
				$test_geocerca='0';
			
				//if($j==0){
				$i=0;   
				$res6=mysql_query($sql6,$conexion);
				while($row = mysql_fetch_array($res6)) {
					$test_geocerca='1';
					$co_coordx=$row["co_coordx"];
					$co_coordy=$row["co_coordy"];
					$nombre_geocerca=$row["nombre_geocerca"];
					$tipo_geo_ciudad=$row["tipo_geo_ciudad"];
					$coordenadas = $co_coordx." ".$co_coordy;
					if($i==0){
						$coord_inicio = $coordenadas;
						$i++;
					}
					array_push($polygon, $coordenadas);
				}
				array_push($polygon, $coord_inicio);            
				$j++;
				//}
			
				//echo "<br>";
				//print_r($polygon);
				//echo "<br>";
			
				foreach($points as $key => $point) {
					$estado_actual = $pointLocation->pointInPolygon($point, $polygon);
				}
	    
				echo "<br>";
	 
				if($estado_control=="in" && $estado_actual=="fuera" && $tipo_cerca=="0" && $func=="0"){
					$estado = "out";
				}elseif($estado_control=="out" && $estado_actual=="dentro" && $tipo_cerca=="0" && $func=="1"){
					$estado = "in";
				}elseif($estado_control=="in" && $estado_actual=="fuera" && $tipo_cerca=="1"){
					$estado = "out";
				}elseif($estado_control=="out" && $estado_actual=="dentro" && $tipo_cerca=="1"){
					$estado = "in";
				}elseif($estado_control=="in" && $estado_actual=="dentro" && $tipo_cerca=="1" && $din2=='0' && $act_contador=='1'){
					$estado = "conteo";
				}

				echo "&nbsp;&nbsp;&nbsp;&nbsp;".$id_vehi."-".$nombre_geocerca."-".$estado_actual."-".$estado."-".$estado_control."-".$id_cerca_total."-".$dentro_de_geocerca;
				echo "<br>";
	        
				if(($estado=="in" and $id_cerca_total<>$dentro_de_geocerca) or ($estado=="out" and $id_cerca_total==$dentro_de_geocerca) ){
					echo "Cambio de estado!!";
					echo "<br>";

					$estado_ant=$estado_control;
					if($centro_control_act=="1"){
						$centro_control="1";
					}else{
						$centro_control="0";
					}
	
					if($estado=='in' && $estado_ant=='out' && $tipo_cerca=="1"){
						$id_alerta = "1";
						echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;*********** Dentro de geocerca *******";
						
						mysql_query("insert into historico_alerta (id_alerta,id_vehi,fe_inicio_alerta,id_reco,ho_inicio_alerta,id_chofer,id_cerca_total,estado,tipo_cerca,id_emp) values ('$id_alerta','$id_vehi','$f_fereg','$id_max_reco','$ho_hora','$id_chofer','$id_cerca_total','$estado','$tipo_cerca','$id_emp')",$conexion);

						$sql6="select max(id_historico) as id_historico from historico_alerta where id_vehi='$id_vehi'"; 
									
						$res6=mysql_query($sql6,$conexion);
						while($row = mysql_fetch_array($res6)) {
							$id_historico=$row["id_historico"];
						}
						echo "<br>id_historico:..".$id_historico;
	 
						mysql_query("update vehiculo set geocerca='in',id_cerca_total='$id_cerca_total',id_historico='$id_historico',tipo_geo_ciudad='$tipo_geo_ciudad',estado_ubic='$taller' where id_vehi='$id_vehi'",$conexion);

						$cambio_estado = 1;
						
					}else if($estado=='out' && $estado_ant=='in' && $tipo_cerca=="1"){
						$id_alerta = "1";
						echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Fuera de geocerca";
						
						mysql_query("insert into historico_alerta (id_alerta,id_vehi,fe_inicio_alerta,id_reco,ho_inicio_alerta,id_chofer,id_cerca_total,estado,tipo_cerca,id_emp) values ('$id_alerta','$id_vehi','$f_fereg','$id_max_reco','$ho_hora','$id_chofer','$id_cerca_total','$estado','$tipo_cerca','$id_emp')",$conexion);

						mysql_query("update vehiculo set geocerca='out',id_cerca_total='0',tipo_geo_ciudad='' where id_vehi='$id_vehi'",$conexion);

						$cambio_estado = 1;
					
					}
			
				}elseif($estado=='conteo'){
					echo "&nbsp;&nbsp;&nbsp;&nbsp;Conteo,no se q sera";
				
					$sql6="select contador from historico_alerta where id_historico='$id_historico_save'"; 
								
					$res6=mysql_query($sql6,$conexion);
					while($row = mysql_fetch_array($res6)) {
						$contador=$row["contador"];
					}
					
					$contador++;
					//echo $contador;
					//echo "<br>";
						
					mysql_query("update historico_alerta set contador='$contador' where id_historico='$id_historico_save'",$conexion);
				
				}
	    
				$contador=0;
				//$id_cerca_total='';
				unset($polygon);
				$polygon = array();
				
				///Solo para verificar que funcione break
				$cuenta1++;
				print $cuenta;
				///Para terminar ciclo de geocercas

				if($cambio_estado == 1){
					echo "&nbsp;&nbsp;$$$$$$$.......... Se rompe la secuencia";
					break 1;
				}


			}
			
		}
		//$id_cerca_total='';
	    	
	}
}

?>
