function initializemap() {
    
    
    google.maps.Polygon.prototype.Contains = function(point) { 
        // ray casting alogrithm http://rosettacode.org/wiki/Ray-casting_algorithm
        var crossings = 0,
            path = this.getPath();
        
        // for each edge
        for (var i=0; i < path.getLength(); i++) {
            var a = path.getAt(i),
                j = i + 1;
            if (j >= path.getLength()) {
                j = 0;
            }
            var b = path.getAt(j);
            if (rayCrossesSegment(point, a, b)) {
                crossings++;
            }
        }
        
        // odd number of crossings?
        return (crossings % 2 == 1);
        
        function rayCrossesSegment(point, a, b) {
            var px = point.lng(),
                py = point.lat(),
                ax = a.lng(),
                ay = a.lat(),
                bx = b.lng(),
                by = b.lat();
            if (ay > by) {
                ax = b.lng();
                ay = b.lat();
                bx = a.lng();
                by = a.lat();
            }
            if (py == ay || py == by) py += 0.00000001;
            if ((py > by || py < ay) || (px > Math.max(ax, bx))) return false;
            if (px < Math.min(ax, bx)) return true;
            
            var red = (ax != bx) ? ((by - ay) / (bx - ax)) : Infinity;
            var blue = (ax != px) ? ((py - ay) / (px - ax)) : Infinity;
            return (blue >= red);
            
        }
       
    };
    
    var myOptions = {
      zoom: 7,
      mapTypeId: google.maps.MapTypeId.ROADMAP,
      mapTypeControl: false,
      streetViewControl: false
    };
    var map = new google.maps.Map(document.getElementById("map-canvas"),myOptions);
    
    var path = [
    new google.maps.LatLng(51.73383267274113, -1.03271484375),
    new google.maps.LatLng(51.45400691005984, -1.4501953125),
    new google.maps.LatLng(51.43346414054374, -1.065673828125),
    new google.maps.LatLng(51.11041991029264, -1.25244140625),
    new google.maps.LatLng(51.09317306026892, -0.802001953125),
    new google.maps.LatLng(51.36835106051133, -0.3790283203125),
    new google.maps.LatLng(51.5463350479341, -0.494384765625),
    new google.maps.LatLng(51.70320428462806, -0.274658203125),
    new google.maps.LatLng(51.85613885029435, -0.2142333984375),
    new google.maps.LatLng(51.83577752045251, -0.8843994140625)];
    
    var polyline = new google.maps.Polygon({path:path, strokeColor: "#FF0000", strokeOpacity: 1.0, strokeWeight: 2, clickable:false});
    polyline.setMap(map);
    map.setCenter(new google.maps.LatLng(52.05249047600099, -0.6097412109375), 8);
    
    google.maps.event.addListener(map, 'click', function(event) {
        if (polyline.Contains(event.latLng)) {
            $('#result').append('<p>That IS inside</p>');
        } else {
            $('#result').append('<p>That is OUTSIDE of the polygon</p>');
        }
      });
    
    //$('#result').append('<p>Ready...</p>');
  }
  
function loadMapScript() {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = "http://maps.google.com/maps/api/js?sensor=false&callback=initializemap&region=GB";
    document.body.appendChild(script);
}
  
 $(document).ready(function() {
     var map_space = $('#map-canvas');
     if (map_space.length > 0) {
         loadMapScript();
     }
 });