<!DOCTYPE html>
<html>
<head>
	<title>Leaflet.CheapLayerAt demo</title>

	<link href="https://leafletjs-cdn.s3.amazonaws.com/content/leaflet/master/leaflet.css" rel="stylesheet" type="text/css" />
	<script src="https://leafletjs-cdn.s3.amazonaws.com/content/leaflet/master/leaflet.js"></script>

	<script src="Leaflet.CheapLayerAt.js"></script>


</head>
<body>
	<div id="map" style="width: 800px; height: 600px; border: 1px solid #ccc"></div>

	<div id='message'>This page calls <code>map.getLayerAt()</code> at every <code>moveend</code> event. Pan the map around!</div>

	<script>
		var osmUrl = 'http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
			osmAttrib = '&copy; <a href="http://openstreetmap.org/copyright">OpenStreetMap</a> contributors',
			osm = L.tileLayer(osmUrl, {maxZoom: 18, attribution: osmAttrib});
		var map = new L.Map('map', {layers: [osm]});
		var canvas = L.canvas();
		var poly = L.polygon([
			[[60, 30], [60, 50], [40, 50]],
			[[20, 50], [20, 70], [0, 70]]
		], {color: 'red', name:'Red polygons'}).addTo(map).bindPopup('Hello SVG');
		var path = L.polygon([
			[[[50.5, 30.5], [50.5, 40], [40, 40]]],
			[[[20, 0], [20, 40], [0, 40]]]
		], { color: 'blue', name:'Blue polygons'}).addTo(map);
		var circle = L.circle([35, 0], 700000, {color: 'green', name: 'Green circle'}).addTo(map);
		var circleMarker = L.circleMarker([35, 30], {color: 'magenta', radius: 30, name: 'Magenta circle'}).addTo(map);
		// map.on('mousemove', function (e) {
		// 	circle.setLatLng(e.latlng);
		// });
		path.on('click', function(ev) {
			console.log(ev);
		});
		map.setView([36, 52], 3);
		map.on('moveend', function() {
			var layer = map.getLayerAt(400, 300);
			var layerName = layer ? layer.options.name : 'none';
			document.getElementById('message').innerHTML = 'Layer at map center point: <strong>' + layerName + '</strong>';
		}, 1000);
	</script>
</body>
</html>
