<!DOCTYPE html>
<html>
  <head>
    <title>Navigation Functions (Heading)</title>
    <meta name="viewport" content="initial-scale=1.0, user-scalable=no">
    <meta charset="utf-8">
    <style>
      /* Always set the map height explicitly to define the size of the div
       * element that contains the map. */
      #map {
        height: 100%;
      }
      /* Optional: Makes the sample page fill the window. */
      html, body {
        height: 100%;
        margin: 0;
        padding: 0;
      }
      #floating-panel {
        position: absolute;
        top: 10px;
        left: 25%;
        z-index: 5;
        background-color: #fff;
        padding: 5px;
        border: 1px solid #999;
        text-align: center;
        font-family: 'Roboto','sans-serif';
        line-height: 30px;
        padding-left: 10px;
      }
    </style>
  </head>
  <body>
    <div id="map"></div>
    <div id="floating-panel">
      Pto1: <input type="text" readonly id="pto1">
      Pto2: <input type="text" readonly id="pto2"><br>
      Pto3: <input type="text" readonly id="pto3"><br>
      Heading: <input type="text" readonly id="heading"> degrees
    </div>
    <script>
      // This example requires the Geometry library. Include the libraries=geometry
      // parameter when you first load the API. For example:
      // <script src="https://maps.googleapis.com/maps/api/js?key=YOUR_API_KEY&libraries=geometry">

      var marker1, marker2, marker3;
      	var poly, geodesicPoly;

      function initMap() {
        var map = new google.maps.Map(document.getElementById('map'), {
          zoom: 4,
          center: {lat: 34, lng: -40.605}
        });

        map.controls[google.maps.ControlPosition.TOP_CENTER].push(
            document.getElementById('info'));

        marker1 = new google.maps.Marker({
          map: map,
          draggable: true,
          position: {lat: 40.714, lng: -74.006}
        });

        marker2 = new google.maps.Marker({
          map: map,
          draggable: true,
          position: {lat: 48.857, lng: 2.352}
        });

        marker3 = new google.maps.Marker({
          map: map,
          draggable: true,
          position: {lat: 18.275, lng: -66.607}
        });


        var bounds = new google.maps.LatLngBounds(
            marker1.getPosition(), marker2.getPosition(),marker3.getPosition());
        map.fitBounds(bounds);
alert(bounds);
        google.maps.event.addListener(marker1, 'position_changed', update);
        google.maps.event.addListener(marker2, 'position_changed', update);
        google.maps.event.addListener(marker3, 'position_changed', update);

        poly = new google.maps.Polyline({
          strokeColor: '#FF0000',
          strokeOpacity: 1.0,
          strokeWeight: 3,
          map: map,
        });
/*
        geodesicPoly = new google.maps.Polyline({
          strokeColor: '#CC0099',
          strokeOpacity: 1.0,
          strokeWeight: 3,
          geodesic: true,
          map: map
        });
*/
        update();
      }

      function update() {
        var path = [marker1.getPosition(), marker2.getPosition(), marker3.getPosition()];
        poly.setPath(path);
        //geodesicPoly.setPath(path);
        //var heading = google.maps.geometry.spherical.computeHeading(path[0], path[1]);
        //document.getElementById('heading').value = heading;
        document.getElementById('pto1').value = path[0].toString();
        document.getElementById('pto2').value = path[1].toString();
        document.getElementById('pto3').value = path[2].toString();
      }
    </script>
    <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyC8x9Nxy9jdfiCTw_V33Wh5fu_SGku2J_8&libraries=geometry&callback=initMap"
        async defer></script>
  </body>
</html>
