<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <title>SelectFeature Control on multiple vector layers</title>
    <link rel="stylesheet" href="../theme/default/style.css" type="text/css">
    <link rel="stylesheet" href="style.css" type="text/css">
    <style type="text/css">
        #controlToggle li {
            list-style: none;
        }
    </style>
<script src="https://cdnjs.cloudflare.com/ajax/libs/openlayers/2.11/lib/OpenLayers.js"></script>
    <script src="http://www.openlayers.org/api/OpenLayers.js"></script>

    <script type="text/javascript">
        var map, selectControl;
        OpenLayers.Feature.Vector.style['default']['strokeWidth'] = '2';
        function init(){
            map = new OpenLayers.Map('map');
            var wmsLayer = new OpenLayers.Layer.WMS(
                    "OpenLayers WMS",
                    "http://vmap0.tiles.osgeo.org/wms/vmap0",
                    {layers:'basic'}
            );
            var v1,v2,v3,s1,h1;
        function internal() {
            var vectors1 = new OpenLayers.Layer.Vector("Vector Layer 1", {
                styleMap:new OpenLayers.StyleMap({
                    "default":new OpenLayers.Style(OpenLayers.Util.applyDefaults({
                        externalGraphic:"../img/marker-green.png",
                        graphicOpacity:1,
                        rotation:-45,
                        pointRadius:10
                    }, OpenLayers.Feature.Vector.style["default"])),
                    "select":new OpenLayers.Style({
                        externalGraphic:"../img/marker-blue.png"
                    }),
                    "highlight":new OpenLayers.Style({
                        externalGraphic:"../img/marker-gold.png"
                    }),
                    "lowlight":new OpenLayers.Style({
                        externalGraphic:"../img/marker-green.png"
                    })
                })
            });
            var vectors2 = new OpenLayers.Layer.Vector("Vector Layer 2", {
                styleMap:new OpenLayers.StyleMap({
                    "default":new OpenLayers.Style(OpenLayers.Util.applyDefaults({
                        fillColor:"red",
                        strokeColor:"gray",
                        graphicName:"square",
                        rotation:45,
                        pointRadius:15
                    }, OpenLayers.Feature.Vector.style["default"])),
                    "select":new OpenLayers.Style(OpenLayers.Util.applyDefaults({
                        fillColor:"black",
                        graphicName:"square",
                        rotation:45,
                        pointRadius:15
                    }, OpenLayers.Feature.Vector.style["select"])),
                    "highlight":new OpenLayers.Style(OpenLayers.Util.applyDefaults({
                        graphicName:"square",
                        fillColor:"green",
                        rotation:45,
                        pointRadius:15
                    }, OpenLayers.Feature.Vector.style["highlight"]))
                })
            });
            var vectors3 = new OpenLayers.Layer.Vector("Vector Layer 3", {
                styleMap:new OpenLayers.StyleMap({
                    "default":new OpenLayers.Style(OpenLayers.Util.applyDefaults({
                        fillColor:"red",
                        strokeColor:"gray",
                        graphicName:"square",
                        rotation:90,
                        pointRadius:15
                    }, OpenLayers.Feature.Vector.style["default"])),
                    "select":new OpenLayers.Style(OpenLayers.Util.applyDefaults({
                        fillColor:"blue",
                        graphicName:"square",
                        rotation:90,
                        pointRadius:15
                    }, OpenLayers.Feature.Vector.style["select"])),
                    "highlight":new OpenLayers.Style(OpenLayers.Util.applyDefaults({
                        graphicName:"square",
                        fillColor:"orange",
                        rotation:90,
                        pointRadius:15
                    }, OpenLayers.Feature.Vector.style["highlight"]))
                })
            });
            map.addLayers([wmsLayer, vectors1, vectors2,vectors3]);
            map.addControl(new OpenLayers.Control.LayerSwitcher());
            function selected(feature) {
                showStatus("select:"+ feature.layer.name +":"+ feature.id);
            }
            function unselected(feature) {
                showStatus("unselected:" + feature.id);
            }
            selectControl = new OpenLayers.Control.SelectFeature(
                    [vectors1, vectors2,vectors3],
                    {
                        onSelect:selected,
                        onUnselect:unselected
                        /*clickout: true, toggle: false,
                         multiple: false, hover: false,
                         toggleKey: "ctrlKey", // ctrl key removes from selection
                         multipleKey: "shiftKey" // shift key adds to selection
                         */
                    }
            );
            highlightControl = new OpenLayers.Control.SelectFeature(
                    [vectors1,vectors2,vectors3],
                    {
                        //clickout: true, toggle: false,
                        multiple:false, hover:true, highlightOnly:true,
                        eventListeners:{
                            featurehighlighted: function (event) {
                                event.feature.layer.drawFeature(
                                        event.feature,
                                        'highlight'
                                );
                            },
                            featureunhighlighted: function (event) {
                                event.feature.layer.drawFeature(
                                        event.feature,
                                        me.getOriginalStyle(
                                                'default'
                                        )
                                );
                            }
                        }
                        //toggleKey: "ctrlKey", // ctrl key removes from selection
                        // multipleKey: "shiftKey" // shift key adds to selection
                    }
            );
            map.addControl(selectControl);
            map.addControl(highlightControl);
            highlightControl.activate();
            selectControl.activate();
            map.setCenter(new OpenLayers.LonLat(0, 0), 3);
            vectors1.addFeatures(createFeatures());
            vectors2.addFeatures(createFeatures());
            vectors3.addFeatures(createFeatures());
            v1 = vectors1;
            v2 = vectors2;
            v3 = vectors3;
            s1 = selectControl;
            h1 = highlightControl;
        }
        function createFeatures() {
            var extent = map.getExtent();
            var features = [];
            for (var i = 0; i < 10; ++i) {
                features.push(new OpenLayers.Feature.Vector(
                        new OpenLayers.Geometry.Point(extent.left + (extent.right - extent.left) * Math.random(),
                                extent.bottom + (extent.top - extent.bottom) * Math.random()
                        )));
            }
            return features;
        }
        function showStatus(text) {
            document.getElementById("status").innerHTML = text;
        }
            internal();
            alert();
            h1.deactivate();
            s1.deactivate();
            map.removeControl(s1);
            map.removeControl(h1);
            map.removeLayer(v1);
            map.removeLayer(v2);
            map.removeLayer(v3);
            internal();
        }
    </script>
</head>
<body onload="init()">
<h1 id="title">OpenLayers Select Feature on Multiple Layers Example</h1>

<div id="tags">
    vector, feature, selecting, selection, advanced
</div>
<p id="shortdesc">
    Select a feature on click with the Control.SelectFeature on multiple
    vector layers.
</p>

<div id="map" class="smallmap"></div>
<div id="status"></div>
</body>
</html>
